<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- cli-setup-toolchains.qdoc -->
  <title>setup-toolchains | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >setup-toolchains</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#synopsis">Synopsis</a></li>
<li class="level1"><a href="#description">Description</a></li>
<li class="level1"><a href="#options">Options</a></li>
<li class="level2"><a href="#op-op-op-op-settings-op-op-dir-op-lt-op-directory-op-gt-op"><code>--settings-dir &lt;directory&gt;</code></a></li>
<li class="level2"><a href="#op-op-op-op-system"><code>--system</code></a></li>
<li class="level2"><a href="#op-op-op-op-detect"><code>--detect</code></a></li>
<li class="level2"><a href="#op-op-op-op-type-op-lt-op-toolchain-type-op-gt-op"><code>--type &lt;toolchain type&gt;</code></a></li>
<li class="level2"><a href="#op-op-op-op-help-op-op-op-op-h-op-op-op-op-op-op"><code>--help|-h|-?</code></a></li>
<li class="level1"><a href="#examples">Examples</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">setup-toolchains</h1>
<span class="subtitle"></span>
<!-- $$$cli-setup-toolchains.html-description -->
<div class="descr"> <a name="details"></a>
<a name="synopsis"></a>
<h2 id="synopsis">Synopsis</h2>
<pre class="cpp">

  qbs setup<span class="operator">-</span>toolchains <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>settings<span class="operator">-</span>dir <span class="operator">&lt;</span>directory<span class="operator">&gt;</span><span class="operator">]</span> <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>system<span class="operator">]</span> <span class="operator">-</span><span class="operator">-</span>detect
  qbs setup<span class="operator">-</span>toolchains <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>settings<span class="operator">-</span>dir <span class="operator">&lt;</span>directory<span class="operator">&gt;</span><span class="operator">]</span> <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>system<span class="operator">]</span> <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>type <span class="operator">&lt;</span>toolchain type<span class="operator">&gt;</span><span class="operator">]</span>
                       <span class="operator">&lt;</span>compiler path<span class="operator">&gt;</span> <span class="operator">&lt;</span>profile name<span class="operator">&gt;</span>

</pre>
<a name="description"></a>
<h2 id="description">Description</h2>
<p>The first form tries to auto-detect all known toolchains, looking them up via the PATH variable.</p>
<p>The second form creates a profile with the name <code>&lt;profile name&gt;</code> for the toolchain located at <code>&lt;compiler path&gt;</code>. It will attempt to determine the toolchain type automatically based on the file name or the compiler executable. If that fails, you need to provide the compiler type as a value of the <code>--type</code> option.</p>
<p>For more information, see <a href="configuring.html">Configuring Profiles and Preferences</a>.</p>
<a name="options"></a>
<h2 id="options">Options</h2>
<a name="op-op-op-op-settings-op-op-dir-op-lt-op-directory-op-gt-op"></a>
<h3 id="op-op-op-op-settings-op-op-dir-op-lt-op-directory-op-gt-op"><code>--settings-dir &lt;directory&gt;</code></h3>
<p>Reads all settings (such as <a href="qml-qbslanguageitems-profile.html">profile</a> information) from the specified <code>&lt;directory&gt;</code>. If the directory does not exist, it will be created.</p>
<p>The default value is system-specific. For example:</p>
<ul>
<li>Linux: <code>$HOME/.config/QtProject/qbs</code></li>
<li>Windows: <code>%APPDATA%\QtProject\qbs</code></li>
<li><a href="nolink">macOS</a>: <code>$HOME/Library/Preferences/qbs</code></li>
</ul>
<a name="op-op-op-op-system"></a>
<h3 id="op-op-op-op-system"><code>--system</code></h3>
<p>If this option is given, the profile(s) created by this tool will end up in the system-level settings and thus be available to all users. Otherwise, they go into the user-level settings.</p>
<a name="op-op-op-op-detect"></a>
<h3 id="op-op-op-op-detect"><code>--detect</code></h3>
<p>Attempts to auto-detect all known toolchains, looking them up in the PATH environment variable.</p>
<a name="op-op-op-op-type-op-lt-op-toolchain-type-op-gt-op"></a>
<h3 id="op-op-op-op-type-op-lt-op-toolchain-type-op-gt-op"><code>--type &lt;toolchain type&gt;</code></h3>
<p>Specifies the type of the toolchain. Needed if Qbs cannot determine the compiler from the name of the executable file located in the specified directory.</p>
<p>Possible values include:</p>
<ul>
<li><code>clang</code></li>
<li><code>gcc</code></li>
<li><code>mingw</code></li>
<li><code>msvc</code></li>
<li><code>iar</code></li>
<li><code>keil</code></li>
<li><code>sdcc</code></li>
</ul>
<a name="op-op-op-op-help-op-op-op-op-h-op-op-op-op-op-op"></a>
<h3 id="op-op-op-op-help-op-op-op-op-h-op-op-op-op-op-op"><code>--help|-h|-?</code></h3>
<p>Displays help for the command.</p>
<a name="examples"></a>
<h2 id="examples">Examples</h2>
<p>Looks up toolchains via the PATH variable and creates profiles for them:</p>
<pre class="cpp">

  qbs setup<span class="operator">-</span>toolchains <span class="operator">-</span><span class="operator">-</span>detect

</pre>
<p>Creates a profile called <code>mingw</code> for the toolchain located in <code>C:\mingw530_32\bin</code> on Windows:</p>
<pre class="cpp">

  qbs setup<span class="operator">-</span>toolchains C:\mingw530_32\bin\g<span class="operator">+</span><span class="operator">+</span><span class="operator">.</span>exe mingw

</pre>
<p>Creates a profile called <code>g++-mingw-w64</code> for the toolchain located in <code>/usr/bin/x86_64-w64-mingw32-g++</code> g++-mingw-w64 on Ubuntu:</p>
<pre class="cpp">

  qbs setup<span class="operator">-</span>toolchains <span class="operator">/</span>usr<span class="operator">/</span>bin<span class="operator">/</span>x86_64<span class="operator">-</span>w64<span class="operator">-</span>mingw32<span class="operator">-</span>g<span class="operator">+</span><span class="operator">+</span> g<span class="operator">+</span><span class="operator">+</span><span class="operator">-</span>mingw<span class="operator">-</span>w64

</pre>
</div>
<!-- @@@cli-setup-toolchains.html -->
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
